
// Copyright (C) 2012 - Digiteo - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

//
// gw_distfun.h
//   Header for the DISTFUN gateway.
//
#ifndef __SCI_GW_DISTFUN_H__
#define __SCI_GW_DISTFUN_H__

	int sci_distfun_grand(char *fname,unsigned long fname_len);
	int sci_distfun_cdft(char* fname,unsigned long l);
	int sci_distfun_cdfbet(char* fname,unsigned long l);
	int sci_distfun_cdfbin(char* fname,unsigned long l);
	int sci_distfun_cdfchi(char* fname,unsigned long l);
	int sci_distfun_cdfchn(char* fname,unsigned long l);
	int sci_distfun_cdff(char* fname,unsigned long l);
	int sci_distfun_cdffnc(char* fname,unsigned long l);
	int sci_distfun_cdfgam(char* fname,unsigned long l);
	int sci_distfun_cdfnbn(char* fname,unsigned long l);
	int sci_distfun_cdfnor(char* fname,unsigned long l);
	int sci_distfun_cdfpoi(char* fname,unsigned long l);

//
// CdfBase
//
int  distfun_cdfbase(char *fname,int inarg,int oarg,int *callpos,char *option,char *errnames,int which,int (*fonc)(),void (*foncErr)() );
/* messages error */
void distfun_CdfDefaultError(char** param, int status, double bound);
void distfun_cdfLowestSearchError(double bound);
void distfun_cdfGreatestSearchError(double bound);

// Uniform Random number generators
int sci_distfun_grandgetsd(char *fname,unsigned long fname_len);
int sci_distfun_grandinitgn(char *fname,unsigned long fname_len);
int sci_distfun_grandsetsd(char *fname,unsigned long fname_len);
int sci_distfun_grandphr2sd(char *fname,unsigned long fname_len);
int sci_distfun_grandsetcgn(char *fname,unsigned long fname_len);
int sci_distfun_grandsetall(char *fname,unsigned long fname_len);
int sci_distfun_grandadvnst(char *fname,unsigned long fname_len);
int sci_distfun_grandgetcgn(char *fname,unsigned long fname_len);
int sci_distfun_grandsetgen(char *fname,unsigned long fname_len);

// Non-Uniform Random number generators
int sci_distfun_grandbet(char *fname,unsigned long fname_len);
int sci_distfun_grandf(char *fname,unsigned long fname_len);
int sci_distfun_grandmul(char *fname,unsigned long fname_len);
int sci_distfun_grandgam(char *fname,unsigned long fname_len);
int sci_distfun_grandnor(char *fname,unsigned long fname_len);
int sci_distfun_grandunf(char *fname,unsigned long fname_len);
int sci_distfun_granduin(char *fname,unsigned long fname_len);
int sci_distfun_grandprm(char *fname,unsigned long fname_len);
int sci_distfun_grandnbn(char *fname,unsigned long fname_len);
int sci_distfun_grandbin(char *fname,unsigned long fname_len);
int sci_distfun_grandmn(char *fname,unsigned long fname_len);
int sci_distfun_grandmarkov(char *fname,unsigned long fname_len);
int sci_distfun_grandnch(char *fname,unsigned long fname_len);
int sci_distfun_grandnf(char *fname,unsigned long fname_len);
int sci_distfun_grandchi(char *fname,unsigned long fname_len);

#endif /* __SCI_GW_DISTFUN_H__ */
