// Copyright (C) 2009 - 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->



//
// References
// Assessing the quality of the Normal distribution function
// References
//   Yalta, A. T. 2008. The accuracy of statistical distributions in Microsoft®Excel 2007. Comput. Stat. Data Anal. 52, 10 (Jun. 2008), 4579-4586. DOI= http://dx.doi.org/10.1016/j.csda.2008.03.005 
//   Computation of Statistical Distributions (ELV), Leo Knüsel 
//
// Table 2
// Check Binomial distribution with parameters (k, n = 1030, p = 0.5)
//

path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","cdf","binomialcdf.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
Xk = evstr(table(:,1));
expected = evstr(table(:,2));

nt = size(table,"r");
precision = 1.e-5;
for k = 1 : nt
  Pr = 0.5;
  Ompr = 1 - Pr;
  Xn = 1030;
  [computed,Q]=cdfbin("PQ",Xk(k),Xn,Pr,Ompr);
  assert_checkalmostequal ( computed , expected(k) , precision );
end

