// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2011 - INRIA - Michael Baudin
// Copyright (C) 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt



//
// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

x = 2;
mu = 1/3;
computed = distfun_expcdf ( x , mu );
expected = 9.975212478233337e-1;
assert_checkalmostequal ( computed , expected , %eps );
//
// Check matrix arguments
x = [2 2 2];
mu = 1 ./ [3 3 3];
computed = distfun_expcdf ( x , mu );
expected = 9.975212478233337e-1*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check argument expansion
x = [2 2 2];
mu = 1/3;
computed = distfun_expcdf ( x , mu );
expected = 9.975212478233337e-1*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );

//
// Check vectorization
mu = 3;
x = linspace(0.1,0.9,10);
p = distfun_expcdf ( x , mu );
p2 = [];
for i = 1 : 10
    p2(1,i) = distfun_expcdf ( x(i) , mu );
end
assert_checkequal(p,p2);

//
// See upper tail, compare with R
p = distfun_expcdf ( 2 , 1/3 );
assert_checkalmostequal ( p , 0.99752124782333362329 , 1.e-15 );
p = distfun_expcdf ( 2 , 1/3 , %f );
assert_checkalmostequal ( p , 0.0024787521766663584907 , 1.e-15 );
