// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2011 - INRIA - Michael Baudin
// Copyright (C) 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt



//
// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

mu=1/2;
p = 9.975212478233336233D-01;
computed = distfun_expinv ( p , mu );
expected=3;
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check matrix arguments
p = 9.975212478233336233D-01 * ones(1,3);
mu = 1 ./ [3 3 3];
computed = distfun_expinv ( p , mu );
expected = 2*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check argument expansion
p = 9.975212478233336233D-01*ones(1,3);
mu = 1/3;
computed = distfun_expinv ( p , mu );
expected = 2*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );

//
// Check vectorization
mu = 3;
p = linspace(0.1,0.9,10);
x = distfun_expinv ( p , mu );
x2 = [];
for i = 1 : 10
    x2(1,i) = distfun_expinv ( p(i) , mu );
end
assert_checkequal(x,x2);

//
// See upper tail, compare with R
p = distfun_expinv ( 0.8 , 1/2 );
assert_checkalmostequal ( p , 0.80471895621705025192 , 10*%eps );
p = distfun_expinv ( 0.8 , 1/2 , %f );
assert_checkalmostequal ( p , 0.11157177565710485467 , 10*%eps );
p = distfun_expinv ( 1.e-20 , 1/2 , %f );
assert_checkalmostequal ( p , 23.025850929940457235 , 10*%eps );
