// Copyright (C) 2011 - INRIA - Michael Baudin
// Copyright (C) 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt



// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

// Set the seed so as to always get the same results.
grand("setsd",1);

// Use R = distfun_exprnd ( mu )
c = distfun_exprnd(1:6);
e = [0.5396058    11.74545    3.8223757    10.785911    0.0005719    0.8226515];
assert_checkalmostequal(c,e,[],1.e-5);


// Check mean and variance for R = distfun_exprnd ( mu )
N = 1000;
for mu = 1:6;
  computed = distfun_exprnd(mu,[1 N]);
  c = mean(computed);
  e = mu;
  assert_checkalmostequal(c,e,1.e-1);
  c = st_deviation(computed);
  e = mu;
  assert_checkalmostequal(c,e,1.e-1);
end
//
// Check R = distfun_exprnd ( mu , v )
grand("setsd",1);
c = distfun_exprnd(2,[1 5]);
e = [1.0792117    11.74545    2.5482505    5.3929557    0.0002288];
assert_checkalmostequal(c,e,[],1.e-5);
//
c = distfun_exprnd(2,[3 2]);
e = [
    0.2742172    0.3174192  
    0.7200255    0.5386079  
    13.898229    0.1937677  
];
assert_checkalmostequal(c,e,[],1.e-5);
//
// Check mean and variance for R = distfun_exprnd ( a , b )
grand("setsd",1);
N = 1000;
mu = 2;
computed = distfun_exprnd(mu,[1 N]);
c = mean(computed(1:N) );
e = mu;
assert_checkalmostequal(c,e,1.e-1);
c = st_deviation(computed(1:N) );
e = mu;
assert_checkalmostequal(c,e,1.e-1);
//
// Check R = distfun_exprnd ( mu , m , n )
grand("setsd",1);
c = distfun_exprnd([1 2 3;4 5 6],2,3);
e = [
    0.5396058    2.5482505    0.0003432  
    23.490899    13.482389    0.8226515  
];
assert_checkalmostequal(c,e,[],1.e-5);
//
c = distfun_exprnd(2,2,3);
e = [
    0.7200255    0.3174192    0.1937677  
    13.898229    0.5386079    1.010286   
];
assert_checkalmostequal(c,e,[],1.e-5);
//
c = distfun_exprnd(1,2,3);
e = [
    0.2061146    0.4239765    0.5054525  
    0.4908772    1.1078933    2.741696   
];
assert_checkalmostequal(c,e,[],1.e-5);
  //
// Check mean and variance for R = distfun_exprnd ( mu )
N = 1000;
mu = 2;
computed = distfun_exprnd(mu,1,N);
c = mean(computed(1:N) );
e = mu;
assert_checkalmostequal(c,e,1.e-1);
c = st_deviation(computed(1:N) );
e = mu;
assert_checkalmostequal(c,e,1.e-1);
if (%f) then
    //
    // Make a plot of the actual distribution of the numbers
    mu = 2;
    data = distfun_exprnd(mu,1,1000);
    histplot(10,data)
    x = linspace(0,14,1000);
    y = distfun_exppdf(x,mu);
    plot(x,y);
end
