// Copyright (C) 2011 - INRIA - Michael Baudin
// Copyright (C) 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

//
// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

x = 2;
mu = 3;
sigma = 4;
computed = distfun_logncdf ( x , mu , sigma );
expected = 2.820666053156566377D-01; // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check matrix arguments
x = [2 2 2];
mu = [3 3 3];
sigma = [4 4 4];
computed = distfun_logncdf ( x , mu , sigma );
expected = 2.820666053156566377D-01*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check default sigma
x = [2 2 2];
mu = [3 3 3];
computed = distfun_logncdf ( x , mu );
expected = 1.053151325275921389D-02*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check default mu
x = [2 2 2];
computed = distfun_logncdf ( x );
expected = 7.558914042144171397D-01*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check argument expansion
x = [2 2 2];
mu = 3;
sigma = 4;
computed = distfun_logncdf ( x , mu , sigma );
expected = 2.820666053156566377D-01*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check zeros
x = [0 1];
p = distfun_logncdf ( x , 0.0 , 10 );
assert_checkequal(p,[0. 0.5]);
//
// Check vectorization
mu = 300;
sigma = 30;
t = linspace(mu-3*sigma,mu+3*sigma,10);
x = exp(t);
p = distfun_logncdf ( x , mu , sigma );
p2 = [];
for i = 1 : 10
    p2(1,i) = distfun_logncdf ( x(i) , mu , sigma );
end
assert_checkequal(p,p2);

// See upper tail : compare with R
expected = 2.0301530180231740447e-14;
p = distfun_logncdf ( 1.e7 , 1. , 2. , %f );
assert_checkalmostequal ( p , expected , 100*%eps );

