// Copyright (C) 2011 - INRIA - Michael Baudin
// Copyright (C) 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt



//
// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

p = 2.820666053156566377D-01; // From Scilab itself
mu = 3;
sigma = 4;
computed = distfun_logninv ( p , mu , sigma );
expected = 2;
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check matrix arguments
p = 2.820666053156566377D-01 * ones(1,3);
mu = [3 3 3];
sigma = [4 4 4];
computed = distfun_logninv ( p , mu , sigma );
expected = 2*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check default sigma
p = 2.820666053156566377D-01*ones(1,3);
mu = [3 3 3];
computed = distfun_logninv ( p , mu );
expected = 1.128288296186385686D+01*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check default mu
p = 2.820666053156566377D-01*ones(1,3);
computed = distfun_logninv ( p );
expected = 5.617416654089230077D-01*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );
//
// Check argument expansion
p = 2.820666053156566377D-01*ones(1,3);
mu = 3;
sigma = 4;
computed = distfun_logninv ( p , mu , sigma );
expected = 2*ones(1,3); // From Scilab itself
assert_checkalmostequal ( computed , expected , 10*%eps );

//
// Check vectorization
mu = 300;
sigma = 30;
p = linspace(0.1,0.9,10);
x = distfun_logninv ( p , mu , sigma );
x2 = [];
for i = 1 : 10
    x2(1,i) = distfun_logninv ( p(i) , mu , sigma );
end
assert_checkequal(x,x2);
//
// See upper tail: compare with R
expected = 4.5117910634839439865;
x = distfun_logninv ( 0.6 , 1. , 2. );
assert_checkalmostequal ( x , expected , 100*%eps );
//
expected = 21481242.111263956875;
x = distfun_logninv ( 1.e-15 , 1. , 2. , %f );
assert_checkalmostequal ( x , expected , 100*%eps );
