// Copyright (C) 2009 - 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->


//
// Test distfun_normrnd
//
// Check R = distfun_normrnd ( mu , sigma )
grand("setsd",1.0);
//
// Test both mu and sigma expanded
computed = distfun_normrnd(1:6,(1:6)^-1);
assert_checkequal ( size ( computed ) , [1 6] );
//
// Test sigma expansion
computed = distfun_normrnd(1:6,2.0);
assert_checkequal ( size ( computed ) , [1 6] );
//
// Test mu expansion
computed = distfun_normrnd(1.0,1:6);
assert_checkequal ( size ( computed ) , [1 6] );
//
// Check expansion of mu and sigma in R = distfun_normrnd(mu,sigma)
//
grand("setsd",1.0);
N = 10;
mu = 1:6;
sigma = (1:6)^-1;
computed1 = [];
for i = 1:N
    computed1(i,1:6) = distfun_normrnd(mu,sigma);
end
grand("setsd",1.0);
computed2  = [];
for i = 1:N
    for k = 1 : 6
        computed2(i,k)=distfun_normrnd(mu(k),sigma(k));
    end
end
assert_checkequal(computed1,computed2);

//
// Check R = distfun_normrnd ( mu , sigma , v )
//
grand("setsd",1.0);
computed = distfun_normrnd(0,1,[1 5]);
assert_checkequal ( size ( computed ) , [1 5] );
computed = distfun_normrnd(0,1,[3 2]);
assert_checkequal ( size ( computed ) , [3 2] );
// Check mean and variance for R = distfun_normrnd ( mu , sigma )
N = 1000;
computed = distfun_normrnd(2,3,[1 N]);
assert_checkalmostequal ( mean(computed(1:N) ) , 2 , 1.e-1 );
assert_checkalmostequal ( st_deviation(computed(1:N) ) , 3 , 1.e-1 );
//
// Check R = distfun_normrnd ( mu , sigma , m , n )
//
grand("setsd",1.0);
computed = distfun_normrnd([1 2 3;4 5 6],0.1,2,3);
assert_checkequal ( size ( computed ) , [2 3] );
computed = distfun_normrnd(0,1,2,3);
assert_checkequal ( size ( computed ) , [2 3] );
computed = distfun_normrnd(1,[1 2 3;4 5 6],2,3);
assert_checkequal ( size ( computed ) , [2 3] );
// Check mean and variance for R = distfun_normrnd ( mu , sigma )
N = 1000;
computed = distfun_normrnd(2,3,1,N);
assert_checkalmostequal ( mean(computed(1:N) ) , 2 , 1.e-1 );
assert_checkalmostequal ( st_deviation(computed(1:N) ) , 3 , 1.e-1 );



