// Copyright (C) 2012 - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->


//
// Test distfun_unifcdf
//
computed = distfun_unifcdf ( [-1 0 0.5 1 2] );
expected = [0. 0. 0.5 1. 1.];
assert_checkalmostequal ( computed , expected , %eps );
//
// Test expanded arguments
computed = distfun_unifcdf ( [1 2 3] , [1 1 1] , [4 5 6] );
expected = [ 0. 0.25 0.4];
assert_checkalmostequal ( computed , expected , %eps );


//
// Check vectorization
a = 10;
b = 300;
x = linspace(a-10,b+10,10);
p = distfun_unifcdf ( x , a , b );
p2 = [];
for i = 1 : 10
    p2(1,i) = distfun_unifcdf ( x(i) , a , b );
end
assert_checkequal(p,p2);

// See upper tail
p = distfun_unifcdf ( 1.7, 1., 2. );
assert_checkalmostequal ( p , 0.7 , %eps );
q = distfun_unifcdf ( 1.7, 1., 2. , %f );
assert_checkalmostequal ( q , 0.3 , %eps );
