// Copyright (C) 2009 - 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->


// Check with default a and b
p = [0.01 0.5 0.99];
x = distfun_unifinv(p);
expected = [0.01 0.5 0.99];
assert_checkalmostequal ( x , expected , 1.e-8 );

// Check expansion of a and b
x = distfun_unifinv([0.5 0.9 0.7],1.0,2.0);
expected = [1.5    1.9    1.7];
assert_checkalmostequal ( x , expected , 1.e-8 );
//
// Check with expanded a and b
x=distfun_unifinv([0.5 0.9 0.7],[1 1 1],[2 2 2]);
expected = [1.5    1.9    1.7];
assert_checkalmostequal ( x , expected , 1.e-8 );


//
// Check vectorization
a = 1;
b = 3;
p = linspace(0.1,0.9,10);
x = distfun_unifinv ( p , a , b );
x2 = [];
for i = 1 : 10
    x2(1,i) = distfun_unifinv ( p(i) , a , b );
end
assert_checkequal(x,x2);

// See upper tail
x=distfun_unifinv(1.e-15,1.,2.);
assert_checkalmostequal ( x , 1. );
x=distfun_unifinv(1.e-15,1.,2.,%f);
assert_checkalmostequal ( x , 2. );
