// Copyright (C) 2012 - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->


//
// Test distfun_unifpdf
//
computed = distfun_unifpdf ( [-1 0 0.5 1 2] );
expected = [0. 1. 1. 1. 0.];
assert_checkalmostequal ( computed , expected , %eps );
//
// Test expanded arguments
computed = distfun_unifpdf ( [1 2 3] , [1 1 1] , [4 5 6] );
expected = [ 1/3 0.25 0.2];
assert_checkalmostequal ( computed , expected , %eps );


//
// Check vectorization
a = 10;
b = 300;
x = linspace(a-10,b+10,10);
p = distfun_unifpdf ( x , a , b );
p2 = [];
for i = 1 : 10
    p2(1,i) = distfun_unifpdf ( x(i) , a , b );
end
assert_checkequal(p,p2);

//
// Check consistency CDF/PDF
n = 10;
a = 3;
b = 5;
p = linspace(0.01,0.99,n)';
x = distfun_unifinv(p,a,b);
p1 = distfun_unifpdf ( x , a , b );
p2 = [];
for i = 1 : n
    p2(i) = derivative(list(distfun_unifcdf,a,b),x(i));
end
assert_checkalmostequal ( p1 , p2 , 1.e-7 , [] , "element");
