// Copyright (C) 2012 - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->


////////////////////////////////////////////////////////////
//
// Test R = distfun_unifrnd ( a , b )
grand("setsd",1.0);
//
// Test both a and b expanded
computed = distfun_unifrnd(1:6,2:7);
assert_checkequal ( size ( computed ) , [1 6] );
//
// Test a expansion
computed = distfun_unifrnd(1:6,7.0);
assert_checkequal ( size ( computed ) , [1 6] );
//
// Test b expansion
computed = distfun_unifrnd(1.0,2:7);
assert_checkequal ( size ( computed ) , [1 6] );
//
// Check expansion of a and b in R = distfun_unifrnd(a,b)
//
grand("setsd",1.0);
N = 10;
a = (1:6)^-1;
b = 1:6;
computed1 = [];
for i = 1:N
    computed1(i,1:6) = distfun_unifrnd(a,b);
end
grand("setsd",1.0);
computed2  = [];
for i = 1:N
    for k = 1 : 6
        computed2(i,k)=distfun_unifrnd(a(k),b(k));
    end
end
assert_checkequal(computed1,computed2);
////////////////////////////////////////////////////////////
//
// Check R = distfun_unifrnd ( a , b , v )
//
grand("setsd",1.0);
computed = distfun_unifrnd(2,3,[1 5]);
assert_checkequal ( size ( computed ) , [1 5] );
computed = distfun_unifrnd(2,3,[3 2]);
assert_checkequal ( size ( computed ) , [3 2] );
// Check mean and variance for R = distfun_unifrnd ( a , b )
N = 1000;
a = 2;
b = 3;
computed = distfun_unifrnd(2,3,[1 N]);
c = mean(computed(1:N) );
[M,V] = distfun_unifstat ( a , b );
assert_checkalmostequal ( c , M , 1.e-1 );
c = st_deviation(computed(1:N) );
assert_checkalmostequal ( c.^2 , V , 1.e-1 );
////////////////////////////////////////////////////////////
//
// Check R = distfun_unifrnd ( a , b , m , n )
//
grand("setsd",1.0);
computed = distfun_unifrnd([1 2 3;4 5 6],7,2,3);
assert_checkequal ( size ( computed ) , [2 3] );
computed = distfun_unifrnd(2,3,2,3);
assert_checkequal ( size ( computed ) , [2 3] );
computed = distfun_unifrnd(0,[1 2 3;4 5 6],2,3);
assert_checkequal ( size ( computed ) , [2 3] );
// Check mean and variance for R = distfun_unifrnd ( a , b )
N = 1000;
a = 2;
b = 3;
computed = distfun_unifrnd(a,b,1,N);
c = mean(computed(1:N) );
[M,V] = distfun_unifstat ( a , b );
assert_checkalmostequal ( c , M , 1.e-1 );
c = st_deviation(computed(1:N) );
assert_checkalmostequal ( c.^2 , V , 1.e-1 );
